#
# Copyright (c) 2002, Jason Erickson <jerickso@stickpeople.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
# * Neither the name of Jason Erickson nor the names of its contributors
#   may be used to endorse or promote products derived from this software
#   without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.



from qt import *
from win32com.client.dynamic import Dispatch

import threading
import string
import sys

#import vim
#import message

class VimButton:
  def __init__(self, filename):
    # Get only the filename from the file
    index = string.rfind(filename, '\\')
    text = filename[index+1:]

    self.fileName = filename
    self.displayName = text
    self.button = 0
    self.command = 0
    self.x = 0
    self.y = 0


class QTGUI(QWidget):
  def __init__(self, parent=None, name="Keypad", f=0):
    QWidget.__init__(self, parent, name, f)

#    self.pipe = message.inputMethod(args)

    self.button = {} # Dictionary for each button

    # Initialize the editor
#    self.editor = vim.VIM()

    # Spin off a thread to wait for new files from a 'pipe'
#    self.thread = threading.Thread(None, self.mmain)
    self.stopThread = 0
#    self.thread.start()

    self.vgrid = QVBoxLayout(self)
    self.hgrid = []
    self.hgrid.append(QHBoxLayout(self.vgrid))
    self.rows = []

    # Poll for changes on vim


  def remove(self, file):
    self.editor.remove(file)


  def insert(self, file):
    self.button[file] = VimButton(file)

    # Define the button
    self.button[file].button = QPushButton(self.button[file].displayName, self)
    QToolTip.add(self.button[file].button, file)

    # Define a command for the button
    self.button[file].command = lambda self=self, file=file:self.select(file)
    QObject.connect(self.button[file].button, SIGNAL("clicked()"),
                self.button[file].command)


    # Resort the buttons and then recreate the widget
    array = self.button.keys()
    array.sort()
#    self.hgrid.append(QHBoxLayout(self.vgrid))

    if len(array) > 0:
      for i in range(len(array)):
        if array[i] == file:
          self.hgrid[0].insertWidget(i, self.button[file].button)
    else:
      self.hgrid[0].addWidget(self.button[file].button)

    # Now show the button
    self.button[file].button.show()

    # TODO:
    # removeChilde


  def select(self, file, lineNum = 0):
#    self.editor.select(file, lineNum)
    print 'file', file, 'selected'

  def stop(self):
    self.stopThread = 1
#    del self.pipe
#    del self.editor

  def __del__(self):
    self.stop()


if __name__ == "__main__":
  a = QApplication(sys.argv)
  v = QTGUI()

  a.setMainWidget(v)

  v.insert("C:\\this is\\the tooltip\\textfortheendofstory.py")
  v.show()
  v.insert("C:\\this is\\the tooltip\\text2")
  v.insert("C:\\this is\\the toip\\texu2")
  v.insert("C:\\howlycow, how did this get to be like this")
  v.insert("C:\\this is one long button string here")
  v.insert("C:\\how much more do we have to go through")
  v.insert("C:\\how much more do we have to go through2")
  v.insert("C:\\how much more do we have to go through3")
  v.insert("C:\\how much more do we have to go through4")

  a.exec_loop()

