#
# Copyright (c) 2002, Jason Erickson <jerickso@stickpeople.com>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice,
#   this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
# * Neither the name of Jason Erickson nor the names of its contributors
#   may be used to endorse or promote products derived from this software
#   without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.



from Tkinter import *
from win32com.client.dynamic import Dispatch

import threading
import string

import vim
import message


class TKGUI:
  def __init__(self, args = []):
    # Do we already exist?
      self.pipe = message.inputMethod(args)

#    if(self.pipe.first() == 1):
      self.dict = {}

      # Intialize TK
      self.root = Tk()

      # Initialize the editor
      self.editor = vim.VIM()

      # Spin off a thread to wait for new files from a 'pipe'
#      self.thread = threading.Thread(None, self.mmain)
      self.stopThread = 0
#      self.thread.start()


      # Have TK poll for changes on vim
      self.tkmain()

      # Start the mainloop for TK
      self.root.mainloop()


  def tkmain(self):
    # Poll vim to see if there are any changes
    list = self.editor.files()
    list.sort()


    # Make sure that all the keys are updated
    for i in list:
      # If the elements are not the same
      if self.dict.has_key(i) != 1:
        self.insert(i)

    # Get a list of keys
    array = self.dict.keys()
    array.sort()


    # Make sure that we do not have more keys than what is actually there
    if len(list) != len(array):
      # Use the size of list since it will never be smaller than that
      for i in range(len(list)):
        while list[i] != array[i]:
          self.dict[array[i]].destroy()
          del self.dict[array[i]]
          del array[i]

      # If the sizes are different, it is because extra stuff at the end
      while len(list) != len(array):
        self.dict[array[len(array)-1]].destroy()
        del self.dict[array[len(array)-1]]
        del array[len(array)-1]


    # Repost itself to the poller
    if self.stopThread == 0:
      self.root.after(1000, self.tkmain)


  def mmain(self):
    # Wait for
#    editor = Dispatch('Vim.Application')
#    editor = vim.VIM()
    editor = self.editor
    while self.stopThread == 0:
      # Perform a read from the device
      file = self.pipe.poll()

      # Check the file length
      if len(file) != 0:
        # Open the file in the editor
        editor.insert(file)
        pass
        # Polling will automaticly update the buttons
#        self.insert(file)


  def remove(self, file):
    self.editor.remove(file)


  def insert(self, file):
    # Get only the file name from the file
    index = string.rfind(file, '\\')
    text = file[index+1:]

    # Define command for the button
    comm = lambda self=self, file=file: self.select(file)

    # Setup the button
    button = Button(self.root, text=text, command=comm)


    # Figure out where to put the button
    array = self.dict.keys()
    array.sort()


    # TODO: better logic to create rows and columns
    bbutton = None

    for i in array:
      if string.lower(i) > string.lower(text):
        bbutton = self.dict[i]
        button.pack(side='left', before=bbutton)
        break

    if bbutton == None:
      # If this is the first element
      if len(array) == 0:
        button.pack(side='left')
      else:
        bbutton = self.dict[array[len(array) - 1]]
        button.pack(side='left', after=bbutton)


    # Store the button
    self.dict[file] = button


  def select(self, file, lineNum = 0):
    self.editor.select(file, lineNum)


  def stop(self):
    self.stopThread = 1
    del self.pipe
    del self.editor

  def __del__(self):
    self.stop()

if __name__ == "__main__":
  a = TKGUI()
